diff --git a/server/responder/nss/nsssrv_cmd.c b/server/responder/nss/nsssrv_cmd.c
index 8ca0be6..87886a3 100644
--- a/server/responder/nss/nsssrv_cmd.c
+++ b/server/responder/nss/nsssrv_cmd.c
@@ -464,7 +464,7 @@ static void nss_cmd_getpwnam_callback(void *ptr, int status,
                 ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                               dctx->domain, &sysdb);
                 if (ret != EOK) {
-                    DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+                    SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
                     NSS_CMD_FATAL_ERROR(cctx);
                 }
                 ret = sysdb_getpwnam(cmdctx, sysdb,
@@ -562,7 +562,7 @@ static void nss_cmd_getpwnam_dp_callback(uint16_t err_maj, uint32_t err_min,
     ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                   dctx->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         NSS_CMD_FATAL_ERROR(cctx);
     }
     ret = sysdb_getpwnam(cmdctx, sysdb,
@@ -692,7 +692,7 @@ static int nss_cmd_getpwnam(struct cli_ctx *cctx)
     ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                   dctx->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         ret = EFAULT;
         goto done;
     }
@@ -782,8 +782,8 @@ static void nss_cmd_getpwuid_callback(void *ptr, int status,
                 ret = ENOENT;
             }
             if (dom == NULL) {
-                DEBUG(0, ("No matching domain found for [%lu], fail!\n",
-                          (unsigned long)cmdctx->id));
+                SYSLOG_ERROR("No matching domain found for [%lu], fail!\n",
+                          (unsigned long)cmdctx->id);
                 ret = ENOENT;
             }
 
@@ -799,7 +799,7 @@ static void nss_cmd_getpwuid_callback(void *ptr, int status,
                 ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                               dctx->domain, &sysdb);
                 if (ret != EOK) {
-                    DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+                    SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
                     NSS_CMD_FATAL_ERROR(cctx);
                 }
                 ret = sysdb_getpwuid(cmdctx, sysdb,
@@ -897,7 +897,7 @@ static void nss_cmd_getpwuid_dp_callback(uint16_t err_maj, uint32_t err_min,
     ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                   dctx->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         NSS_CMD_FATAL_ERROR(cctx);
     }
     ret = sysdb_getpwuid(cmdctx, sysdb,
@@ -985,7 +985,7 @@ static int nss_cmd_getpwuid(struct cli_ctx *cctx)
         ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                       dctx->domain, &sysdb);
         if (ret != EOK) {
-            DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+            SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
             ret = EFAULT;
             goto done;
         }
@@ -1113,7 +1113,7 @@ static void nss_cmd_setpwent_callback(void *ptr, int status,
             ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                           dctx->domain, &sysdb);
             if (ret != EOK) {
-                DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+                SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
                 NSS_CMD_FATAL_ERROR(cctx);
             }
             ret = sysdb_enumpwent(dctx, sysdb,
@@ -1174,7 +1174,7 @@ static void nss_cmd_setpw_dp_callback(uint16_t err_maj, uint32_t err_min,
     ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                   dctx->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         NSS_CMD_FATAL_ERROR(cctx);
     }
     ret = sysdb_enumpwent(cmdctx, sysdb,
@@ -1260,7 +1260,7 @@ static int nss_cmd_setpwent_ext(struct cli_ctx *cctx, bool immediate)
         ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                       dctx->domain, &sysdb);
         if (ret != EOK) {
-            DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+            SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
             ret = EFAULT;
             goto done;
         }
@@ -1798,7 +1798,7 @@ static void nss_cmd_getgrnam_callback(void *ptr, int status,
                 ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                               dctx->domain, &sysdb);
                 if (ret != EOK) {
-                    DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+                    SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
                     NSS_CMD_FATAL_ERROR(cctx);
                 }
                 ret = sysdb_getgrnam(cmdctx, sysdb,
@@ -1892,7 +1892,7 @@ static void nss_cmd_getgrnam_dp_callback(uint16_t err_maj, uint32_t err_min,
     ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                   dctx->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         NSS_CMD_FATAL_ERROR(cctx);
     }
     ret = sysdb_getgrnam(cmdctx, sysdb,
@@ -2022,7 +2022,7 @@ static int nss_cmd_getgrnam(struct cli_ctx *cctx)
     ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                   dctx->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         ret = EFAULT;
         goto done;
     }
@@ -2113,8 +2113,8 @@ static void nss_cmd_getgrgid_callback(void *ptr, int status,
                 ret = ENOENT;
             }
             if (dom == NULL) {
-                DEBUG(0, ("No matching domain found for [%lu], fail!\n",
-                          (unsigned long)cmdctx->id));
+                SYSLOG_ERROR("No matching domain found for [%lu], fail!\n",
+                          (unsigned long)cmdctx->id);
                 ret = ENOENT;
             }
 
@@ -2130,7 +2130,7 @@ static void nss_cmd_getgrgid_callback(void *ptr, int status,
                 ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                               dctx->domain, &sysdb);
                 if (ret != EOK) {
-                    DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+                    SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
                     NSS_CMD_FATAL_ERROR(cctx);
                 }
                 ret = sysdb_getgrgid(cmdctx, sysdb,
@@ -2222,7 +2222,7 @@ static void nss_cmd_getgrgid_dp_callback(uint16_t err_maj, uint32_t err_min,
     ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                   dctx->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         NSS_CMD_FATAL_ERROR(cctx);
     }
     ret = sysdb_getgrgid(cmdctx, sysdb,
@@ -2310,7 +2310,7 @@ static int nss_cmd_getgrgid(struct cli_ctx *cctx)
         ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                       dctx->domain, &sysdb);
         if (ret != EOK) {
-            DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+            SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
             ret = EFAULT;
             goto done;
         }
@@ -2434,7 +2434,7 @@ static void nss_cmd_setgrent_callback(void *ptr, int status,
             ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                           dctx->domain, &sysdb);
             if (ret != EOK) {
-                DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+                SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
                 NSS_CMD_FATAL_ERROR(cctx);
             }
             ret = sysdb_enumgrent(dctx, sysdb,
@@ -2495,7 +2495,7 @@ static void nss_cmd_setgr_dp_callback(uint16_t err_maj, uint32_t err_min,
     ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                   dctx->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         NSS_CMD_FATAL_ERROR(cctx);
     }
     ret = sysdb_enumgrent(dctx, sysdb,
@@ -2581,7 +2581,7 @@ static int nss_cmd_setgrent_ext(struct cli_ctx *cctx, bool immediate)
         ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                       dctx->domain, &sysdb);
         if (ret != EOK) {
-            DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+            SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
             ret = EFAULT;
             goto done;
         }
@@ -2824,7 +2824,7 @@ static void nss_cmd_getinitgr_callback(uint16_t err_maj, uint32_t err_min,
     ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                   dctx->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         NSS_CMD_FATAL_ERROR(cctx);
     }
     ret = sysdb_initgroups(cmdctx, sysdb,
@@ -2875,7 +2875,7 @@ static void nss_cmd_getinitnam_dp_callback(uint16_t err_maj, uint32_t err_min,
     ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                   dctx->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         NSS_CMD_FATAL_ERROR(cctx);
     }
     ret = sysdb_getpwnam(cmdctx, sysdb,
@@ -3021,7 +3021,7 @@ static void nss_cmd_getinit_callback(void *ptr, int status,
                 ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                               dctx->domain, &sysdb);
                 if (ret != EOK) {
-                    DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+                    SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
                     NSS_CMD_FATAL_ERROR(cctx);
                 }
                 ret = sysdb_getpwnam(cmdctx, sysdb,
@@ -3200,7 +3200,7 @@ static int nss_cmd_initgroups(struct cli_ctx *cctx)
     ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                   dctx->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         ret = EFAULT;
         goto done;
     }
diff --git a/server/responder/pam/pam_LOCAL_domain.c b/server/responder/pam/pam_LOCAL_domain.c
index 41d64b3..25a5aed 100644
--- a/server/responder/pam/pam_LOCAL_domain.c
+++ b/server/responder/pam/pam_LOCAL_domain.c
@@ -462,7 +462,7 @@ int LOCAL_pam_handler(struct pam_auth_req *preq)
     ret = sysdb_get_ctx_from_list(preq->cctx->rctx->db_list,
                                   preq->domain, &lreq->dbctx);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         talloc_free(lreq);
         return ret;
     }
diff --git a/server/responder/pam/pamsrv.c b/server/responder/pam/pamsrv.c
index c751528..4e0bf83 100644
--- a/server/responder/pam/pamsrv.c
+++ b/server/responder/pam/pamsrv.c
@@ -48,6 +48,8 @@
 #define PAM_SBUS_SERVICE_NAME "pam"
 #define PAM_SRV_CONFIG "config/services/pam"
 
+#define PRG_NAME "sssd[pam]"
+
 static int service_reload(DBusMessage *message, struct sbus_connection *conn);
 
 struct sbus_method monitor_pam_methods[] = {
@@ -117,7 +119,7 @@ static void pam_dp_reconnect_init(struct sbus_connection *conn, int status, void
     }
 
     /* Handle failure */
-    DEBUG(0, ("Could not reconnect to data provider.\n"));
+    SYSLOG_ERROR("Could not reconnect to data provider.\n");
     /* Kill the backend and let the monitor restart it */
     pam_shutdown(rctx);
 }
@@ -155,7 +157,7 @@ static int pam_process_init(TALLOC_CTX *mem_ctx,
     ret = confdb_get_int(rctx->cdb, rctx, SERVICE_CONF_ENTRY,
                          "reconnection_retries", 3, &max_retries);
     if (ret != EOK) {
-        DEBUG(0, ("Failed to set up automatic reconnection\n"));
+        SYSLOG_ERROR("Failed to set up automatic reconnection\n");
         return ret;
     }
 
@@ -191,8 +193,11 @@ int main(int argc, const char *argv[])
 
 	poptFreeContext(pc);
 
+    /* enable syslog logging */
+    openlog(PRG_NAME, LOG_PID, LOG_DAEMON);
+
     /* set up things like debug , signals, daemonization, etc... */
-    ret = server_setup("sssd[pam]", 0, PAM_SRV_CONFIG, &main_ctx);
+    ret = server_setup(PRG_NAME, 0, PAM_SRV_CONFIG, &main_ctx);
     if (ret != EOK) return 2;
 
     ret = die_if_parent_died();
@@ -209,6 +214,9 @@ int main(int argc, const char *argv[])
     /* loop on main */
     server_loop(main_ctx);
 
+    /* close syslog */
+    closelog();
+
     return 0;
 }
 
diff --git a/server/responder/pam/pamsrv_cache.c b/server/responder/pam/pamsrv_cache.c
index 9c5c209..51e8354 100644
--- a/server/responder/pam/pamsrv_cache.c
+++ b/server/responder/pam/pamsrv_cache.c
@@ -148,7 +148,7 @@ int pam_cache_auth(struct pam_auth_req *preq)
     ret = sysdb_get_ctx_from_list(preq->cctx->rctx->db_list,
                                   preq->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         return ret;
     }
     ret = sysdb_get_user_attr(preq, sysdb,
diff --git a/server/responder/pam/pamsrv_cmd.c b/server/responder/pam/pamsrv_cmd.c
index 671dc08..874ff20 100644
--- a/server/responder/pam/pamsrv_cmd.c
+++ b/server/responder/pam/pamsrv_cmd.c
@@ -532,7 +532,7 @@ static int pam_forwarder(struct cli_ctx *cctx, int pam_cmd)
         ret = sysdb_get_ctx_from_list(cctx->rctx->db_list,
                                       preq->domain, &sysdb);
         if (ret != EOK) {
-            DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+            SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
             goto done;
         }
         ret = sysdb_getpwnam(preq, sysdb,
@@ -584,7 +584,7 @@ static void pam_check_user_dp_callback(uint16_t err_maj, uint32_t err_min,
     ret = sysdb_get_ctx_from_list(preq->cctx->rctx->db_list,
                                   preq->domain, &sysdb);
     if (ret != EOK) {
-        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
         goto done;
     }
     ret = sysdb_getpwnam(preq, sysdb,
@@ -733,7 +733,7 @@ static void pam_check_user_callback(void *ptr, int status,
                     ret = sysdb_get_ctx_from_list(preq->cctx->rctx->db_list,
                                                   preq->domain, &sysdb);
                     if (ret != EOK) {
-                        DEBUG(0, ("Fatal: Sysdb CTX not found for this domain!\n"));
+                        SYSLOG_ERROR("Fatal: Sysdb CTX not found for this domain!\n");
                         preq->pd->pam_status = PAM_SYSTEM_ERR;
                         pam_reply(preq);
                         return;
diff --git a/server/responder/pam/pamsrv_dp.c b/server/responder/pam/pamsrv_dp.c
index 7ea2b7e..3f2a9bc 100644
--- a/server/responder/pam/pamsrv_dp.c
+++ b/server/responder/pam/pamsrv_dp.c
@@ -46,7 +46,7 @@ static void pam_dp_process_reply(DBusPendingCall *pending, void *ptr)
     dbus_pending_call_block(pending);
     msg = dbus_pending_call_steal_reply(pending);
     if (msg == NULL) {
-        DEBUG(0, ("Severe error. A reply callback was called but no reply was received and no timeout occurred\n"));
+        SYSLOG_ERROR("Severe error. A reply callback was called but no reply was received and no timeout occurred\n");
         preq->pd->pam_status = PAM_SYSTEM_ERR;
         goto done;
     }
@@ -57,18 +57,18 @@ static void pam_dp_process_reply(DBusPendingCall *pending, void *ptr)
         case DBUS_MESSAGE_TYPE_METHOD_RETURN:
             ret = dp_unpack_pam_response(msg, preq->pd, &dbus_error);
             if (!ret) {
-                DEBUG(0, ("Failed to parse reply.\n"));
+                SYSLOG_ERROR("Failed to parse reply.\n");
                 preq->pd->pam_status = PAM_SYSTEM_ERR;
                 goto done;
             }
             DEBUG(4, ("received: [%d][%s]\n", preq->pd->pam_status, preq->pd->domain));
             break;
         case DBUS_MESSAGE_TYPE_ERROR:
-            DEBUG(0, ("Reply error.\n"));
+            SYSLOG_ERROR("Reply error.\n");
             preq->pd->pam_status = PAM_SYSTEM_ERR;
             break;
         default:
-            DEBUG(0, ("Default... what now?.\n"));
+            SYSLOG_ERROR("Default... what now?.\n");
             preq->pd->pam_status = PAM_SYSTEM_ERR;
     }
 
@@ -103,7 +103,7 @@ int pam_dp_send_req(struct pam_auth_req *preq, int timeout)
                                        DP_CLI_INTERFACE,
                                        DP_SRV_METHOD_PAMHANDLER);
     if (msg == NULL) {
-        DEBUG(0,("Out of memory?!\n"));
+        SYSLOG_ERROR("Out of memory?!\n");
         return ENOMEM;
     }
 
@@ -124,7 +124,7 @@ int pam_dp_send_req(struct pam_auth_req *preq, int timeout)
          * We can't communicate on this connection
          * We'll drop it using the default destructor.
          */
-        DEBUG(0, ("D-BUS send failed.\n"));
+        SYSLOG_ERROR("D-BUS send failed.\n");
         dbus_message_unref(msg);
         return EIO;
     }
diff --git a/server/sbus/sssd_dbus_common.c b/server/sbus/sssd_dbus_common.c
index e5970a3..8ec1521 100644
--- a/server/sbus/sssd_dbus_common.c
+++ b/server/sbus/sssd_dbus_common.c
@@ -130,7 +130,7 @@ dbus_bool_t sbus_add_watch(DBusWatch *dbus_watch, void *data)
         /* does not exist, allocate new one */
         watch = talloc_zero(conn, struct sbus_watch_ctx);
         if (!watch) {
-            DEBUG(0, ("Out of Memory!\n"));
+            SYSLOG_ERROR("Out of Memory!\n");
             return FALSE;
         }
         watch->conn = conn;
@@ -170,7 +170,7 @@ dbus_bool_t sbus_add_watch(DBusWatch *dbus_watch, void *data)
                                watch, fd, event_flags,
                                sbus_watch_handler, watch);
     if (!watch->fde) {
-        DEBUG(0, ("Failed to set up fd event!\n"));
+        SYSLOG_ERROR("Failed to set up fd event!\n");
         talloc_zfree(watch);
         return FALSE;
     }
@@ -323,7 +323,7 @@ dbus_bool_t sbus_add_timeout(DBusTimeout *dbus_timeout, void *data)
 
     timeout = talloc_zero(conn, struct sbus_timeout_ctx);
     if (!timeout) {
-        DEBUG(0, ("Out of Memory!\n"));
+        SYSLOG_ERROR("Out of Memory!\n");
         return FALSE;
     }
     timeout->dbus_timeout = dbus_timeout;
@@ -332,7 +332,7 @@ dbus_bool_t sbus_add_timeout(DBusTimeout *dbus_timeout, void *data)
     timeout->te = tevent_add_timer(conn->ev, timeout, tv,
                                    sbus_timeout_handler, timeout);
     if (!timeout->te) {
-        DEBUG(0, ("Failed to set up timeout event!\n"));
+        SYSLOG_ERROR("Failed to set up timeout event!\n");
         return FALSE;
     }
 
diff --git a/server/sbus/sssd_dbus_connection.c b/server/sbus/sssd_dbus_connection.c
index 1953ee5..907194f 100644
--- a/server/sbus/sssd_dbus_connection.c
+++ b/server/sbus/sssd_dbus_connection.c
@@ -61,7 +61,7 @@ static void sbus_dispatch(struct tevent_context *ev,
         /* Currently trying to reconnect, defer dispatch */
         new_event = tevent_add_timer(ev, conn, tv, sbus_dispatch, conn);
         if (new_event == NULL) {
-            DEBUG(0,("Could not defer dispatch!\n"));
+            SYSLOG_ERROR("Could not defer dispatch!\n");
         }
         return;
     }
@@ -75,7 +75,7 @@ static void sbus_dispatch(struct tevent_context *ev,
             return;
         }
 
-        DEBUG(0, ("Cannot start auto-reconnection.\n"));
+        SYSLOG_ERROR("Cannot start auto-reconnection.\n");
         conn->reconnect_callback(conn,
                                  SBUS_RECONNECT_ERROR,
                                  conn->reconnect_pvt);
@@ -483,7 +483,7 @@ int sbus_conn_add_interface(struct sbus_connection *conn,
     path = intf->path;
 
     if (path_in_interface_list(conn->intf_list, path)) {
-        DEBUG(0, ("Cannot add method context with identical path.\n"));
+        SYSLOG_ERROR("Cannot add method context with identical path.\n");
         return EINVAL;
     }
 
@@ -499,7 +499,7 @@ int sbus_conn_add_interface(struct sbus_connection *conn,
     dbret = dbus_connection_register_object_path(conn->dbus.conn,
                                                  path, &intf->vtable, intf_p);
     if (!dbret) {
-        DEBUG(0, ("Could not register object path to the connection.\n"));
+        SYSLOG_ERROR("Could not register object path to the connection.\n");
         return ENOMEM;
     }
 
@@ -580,7 +580,7 @@ static void sbus_reconnect(struct tevent_context *ev,
                                                          &iter->intf->vtable,
                                                          iter);
             if (!dbret) {
-                DEBUG(0, ("Could not register object path.\n"));
+                SYSLOG_ERROR("Could not register object path.\n");
                 dbus_connection_unref(conn->dbus.conn);
                 goto failed;
             }
diff --git a/server/tools/tools_util.c b/server/tools/tools_util.c
index eeec13c..34b2881 100644
--- a/server/tools/tools_util.c
+++ b/server/tools/tools_util.c
@@ -226,6 +226,9 @@ int init_sss_tools(struct tools_ctx **_tctx)
     octx->domain = tctx->local;
     tctx->octx = octx;
 
+    /* No syslog in tools */
+    send_syslog = 0;
+
     *_tctx = tctx;
     ret = EOK;
 fini:
diff --git a/server/util/debug.c b/server/util/debug.c
index a7b3a09..f0b5865 100644
--- a/server/util/debug.c
+++ b/server/util/debug.c
@@ -29,6 +29,7 @@
 const char *debug_prg_name = "sssd";
 int debug_level = 0;
 int debug_timestamps = 0;
+int send_syslog = 1;
 
 void debug_fn(const char *format, ...)
 {
diff --git a/server/util/server.c b/server/util/server.c
index 0760e60..c195864 100644
--- a/server/util/server.c
+++ b/server/util/server.c
@@ -62,11 +62,11 @@ static void close_low_fds(bool stderr_too)
 		if (fd < 0)
 			fd = open("/dev/null",O_WRONLY,0);
 		if (fd < 0) {
-			DEBUG(0,("Can't open /dev/null\n"));
+                        SYSLOG_ERROR("Can't open /dev/null\n");
 			return;
 		}
 		if (fd != i) {
-			DEBUG(0,("Didn't get file descriptor %d\n",i));
+                        SYSLOG_ERROR("Didn't get file descriptor %d\n",i);
 			return;
 		}
 	}
@@ -94,8 +94,8 @@ void become_daemon(bool Fork)
         errno = 0;
         if(chdir("/") == -1) {
             ret = errno;
-            DEBUG(0, ("Cannot change directory (%d [%s])\n",
-                    ret, strerror(ret)));
+            SYSLOG_ERROR("Cannot change directory (%d [%s])\n",
+                      ret, strerror(ret));
             return;
         }
 
@@ -187,7 +187,7 @@ static void sig_term(int sig)
 #if HAVE_GETPGRP
 	static int done_sigterm;
 	if (done_sigterm == 0 && getpgrp() == getpid()) {
-		DEBUG(0,("SIGTERM: killing children\n"));
+                SYSLOG_NOTICE("SIGTERM: killing children\n");
 		done_sigterm = 1;
 		kill(-getpgrp(), SIGTERM);
 	}
@@ -201,7 +201,7 @@ static void sig_segv_abrt(int sig)
 #if HAVE_GETPGRP
 	static int done;
 	if (done == 0 && getpgrp() == getpid()) {
-		DEBUG(0,("%s: killing children\n", strsignal(sig)));
+                SYSLOG_NOTICE("%s: killing children\n", strsignal(sig));
 		done = 1;
 		kill(-getpgrp(), SIGTERM);
 	}
@@ -258,7 +258,7 @@ static void server_stdin_handler(struct tevent_context *event_ctx,
 	const char *binary_name = (const char *)private;
 	uint8_t c;
 	if (read(0, &c, 1) == 0) {
-		DEBUG(0,("%s: EOF on stdin - terminating\n", binary_name));
+                SYSLOG_NOTICE("%s: EOF on stdin - terminating\n", binary_name);
 #if HAVE_GETPGRP
 		if (getpgrp() == getpid()) {
 			kill(-getpgrp(), SIGTERM);
@@ -320,8 +320,8 @@ int server_setup(const char *name, int flags,
     if (flags & FLAGS_PID_FILE) {
         ret = pidfile(PID_PATH, name);
         if (ret != EOK) {
-            DEBUG(0, ("Error creating pidfile! (%d [%s])\n",
-                      ret, strerror(ret)));
+            SYSLOG_ERROR("Error creating pidfile! (%d [%s])\n",
+                         ret, strerror(ret));
             return ret;
         }
     }
@@ -335,13 +335,13 @@ int server_setup(const char *name, int flags,
      * Everything else should hang off that */
     event_ctx = tevent_context_init(talloc_autofree_context());
     if (event_ctx == NULL) {
-        DEBUG(0,("The event context initialiaziton failed\n"));
+        SYSLOG_ERROR("The event context initialiaziton failed\n");
         return 1;
     }
 
     ctx = talloc(event_ctx, struct main_context);
     if (ctx == NULL) {
-        DEBUG(0,("Out of memory, aborting!\n"));
+        SYSLOG_ERROR("Out of memory, aborting!\n");
         return ENOMEM;
     }
 
@@ -349,14 +349,14 @@ int server_setup(const char *name, int flags,
 
     conf_db = talloc_asprintf(ctx, "%s/%s", DB_PATH, CONFDB_FILE);
     if (conf_db == NULL) {
-        DEBUG(0,("Out of memory, aborting!\n"));
+        SYSLOG_ERROR("Out of memory, aborting!\n");
         return ENOMEM;
     }
     DEBUG(3, ("CONFDB: %s\n", conf_db));
 
     ret = confdb_init(ctx, &ctx->confdb_ctx, conf_db);
     if (ret != EOK) {
-        DEBUG(0,("The confdb initialization failed\n"));
+        SYSLOG_ERROR("The confdb initialization failed\n");
         return ret;
     }
 
@@ -364,8 +364,8 @@ int server_setup(const char *name, int flags,
     ret = confdb_get_int(ctx->confdb_ctx, ctx, conf_entry,
                          "debug-level", debug_level, &debug_level);
     if (ret != EOK) {
-        DEBUG(0, ("Error reading from confdb (%d) [%s]\n",
-                  ret, strerror(ret)));
+        SYSLOG_ERROR("Error reading from confdb (%d) [%s]\n",
+                     ret, strerror(ret));
         return ret;
     }
 
@@ -374,8 +374,8 @@ int server_setup(const char *name, int flags,
     ret = confdb_get_bool(ctx->confdb_ctx, ctx, conf_entry,
                           "debug-timestamps", dt, &dt);
     if (ret != EOK) {
-        DEBUG(0, ("Error reading from confdb (%d) [%s]\n",
-                  ret, strerror(ret)));
+        SYSLOG_ERROR("Error reading from confdb (%d) [%s]\n",
+                     ret, strerror(ret));
         return ret;
     }
     if (dt) debug_timestamps = 1;
diff --git a/server/util/util.h b/server/util/util.h
index ea7f44e..1b03963 100644
--- a/server/util/util.h
+++ b/server/util/util.h
@@ -30,6 +30,7 @@
 #include <limits.h>
 #include <time.h>
 #include <pcre.h>
+#include <syslog.h>
 #include "config.h"
 #include "talloc.h"
 #include "tevent.h"
@@ -43,6 +44,7 @@ typedef int errno_t;
 extern const char *debug_prg_name;
 extern int debug_level;
 extern int debug_timestamps;
+extern int send_syslog;
 void debug_fn(const char *format, ...);
 
 #define SSSD_DEBUG_OPTS \
@@ -81,6 +83,20 @@ void debug_fn(const char *format, ...);
 #define PRINT(fmt, ...) fprintf(stdout, gettext(fmt), ##__VA_ARGS__)
 #define ERROR(fmt, ...) fprintf(stderr, gettext(fmt), ##__VA_ARGS__)
 
+#define SYSLOG_ERROR(...) do { \
+    DEBUG(0, (__VA_ARGS__)); \
+    if (send_syslog) { \
+        syslog(LOG_ERR, __VA_ARGS__); \
+    } \
+} while(0);
+
+#define SYSLOG_NOTICE(...) do { \
+    DEBUG(0, (__VA_ARGS__)); \
+    if (send_syslog) { \
+        syslog(LOG_NOTICE, __VA_ARGS__); \
+    } \
+} while(0);
+
 #ifndef discard_const
 #define discard_const(ptr) ((void *)((uintptr_t)(ptr)))
 #endif
-- 
1.6.2.5

